var inline_fragment;
var inline_fragment_size_set = false;
var middleAd = false;
var canShowAd = false;
var positionFixed = false;
var intervalId;

var FALLBACK_INLINE_FRAGMENT_WIDTH = 300;
var FALLBACK_INLINE_FRAGMENT_HEIGHT = 250;

var DEFAULT_INLINE_FRAGMENT_WIDTH = 300;
var DEFAULT_INLINE_FRAGMENT_HEIGHT = 1;

    // For really old browser's or incompatible ones
    function getOffsetSum(elem) {
        var top = 0,
            left = 0,
            bottom = 0,
            right = 0;

        var width = elem.offsetWidth;
        var height = elem.offsetHeight;
                
        while (elem) {
            top += elem.offsetTop;
            left += elem.offsetLeft;
            elem = elem.offsetParent;
        }

        right = left + width;
        bottom = top + height;

        return {
            top: top,
            left: left,
            bottom: bottom,
            right: right,
            //windowHeight: screen.availHeight,
            //windowWidth: screen.availWidth
        }
    };

    function getOffsetRect(elem) {
        var box = elem.getBoundingClientRect();

        var body = document.body;
        var docElem = document.documentElement;

        var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop;
        var scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;

        var clientTop = docElem.clientTop;
        var clientLeft = docElem.clientLeft;

        //consoleLog("scrollTop: " + scrollTop + " scrollLeft: " + scrollLeft + " clientTop: " + clientTop + " clientLeft: " + clientLeft);

        var top = box.top + scrollTop - clientTop;
        var left = box.left + scrollLeft - clientLeft;
        var bottom = top + (box.bottom - box.top);
        var right = left + (box.right - box.left);

        if (!positionFixed && canShowAd) {
            var inlineFragmentWidth = parseInt(inline_fragment.style.width.replace('px', ''));
             if (left < 0 || left + inlineFragmentWidth > screen.width) {
                inline_fragment.style.marginLeft = ((screen.width - inlineFragmentWidth) / 4) + 'px';
                inline_fragment.style.marginRight = '0px';
                positionFixed = true;
                console.log('Inline Ad Position Fixed to center.');
             }
        }

        return {
            top: Math.round(top),
            left: Math.round(left),
            bottom: Math.round(bottom),
            right: Math.round(right),
            // windowHeight: screen.availHeight,
            // windowWidth: screen.availWidth
        }
    };

    function getOffset(elem) {
        if (elem) {
            if (elem.getBoundingClientRect) {
                return getOffsetRect(elem);
            } else { // old browser
                return getOffsetSum(elem);
            }
        } else {
            return null;
        }
    };

    function getInlineFragmentOffset() {
        if (inline_fragment == null) {
            inline_fragment = document.getElementById('vrv-inline-ad-container');
        }

        if (inline_fragment != null) {
            if (middleAd) {
                if (!inline_fragment_size_set) {
                    //Colored background of inline fragment for debugging.
                    //inline_fragment.style.backgroundColor = 'yellow';
                    inline_fragment.style.width = DEFAULT_INLINE_FRAGMENT_WIDTH + 'px';
                    inline_fragment.style.height = DEFAULT_INLINE_FRAGMENT_HEIGHT + 'px';
                    inline_fragment_size_set = true;
                }
            }

            var imgRect = getOffset(inline_fragment);
            var stringToJava = (imgRect == null) ? "null" : JSON.stringify(imgRect);

            // Notify Android of the size
            if (canShowAd) {
                MiddleAdAndroidBridge.onImageSizeKnown(stringToJava);
            }
        } else {
            //console.log("Inline Fragment not found !!!")
        }
    };

    function bodyOnLoad(middleAd) {
        this.middleAd = middleAd;
        getInlineFragmentOffset();
    };

    function setMiddleAdLoadedSize(sJsonSize, animate) {
        //Local vars
        var size = undefined;
        var height = undefined;
        var width = undefined;
        //Check passed JSON string and convert it to object.
        if (sJsonSize !== undefined) {
            size = JSON.parse(sJsonSize);
        }
        //Get height
        if (size === undefined || size.height === undefined || isNaN(size.height)) {
            height = FALLBACK_INLINE_FRAGMENT_HEIGHT;
        } else {
            height = size.height;
        }
        //Get width
        if (size === undefined || size.width === undefined || isNaN(size.width)) {
            width = FALLBACK_INLINE_FRAGMENT_WIDTH;
        } else {
            width = size.width;
        }

        if (middleAd) {
            if(animate) {
                animatedResize(width, height);
            } else {
                resize(width, height);
            }
        }
    };

    function setCanShowAd() {
        canShowAd = true;
    };

    function resetForNewAd() {
        positionFixed = false;
        canShowAd = false;
        inline_fragment_size_set = false;
        if (inline_fragment == null) {
               inline_fragment = document.getElementById('vrv-inline-ad-container');
        }

        if (inline_fragment != null) {
            if (middleAd) {
                if (!inline_fragment_size_set) {
                    inline_fragment.style.width = FALLBACK_INLINE_FRAGMENT_WIDTH + 'px';
                    inline_fragment.style.height = FALLBACK_INLINE_FRAGMENT_HEIGHT + 'px';
                    inline_fragment_size_set = true;
                }
            }
        }
    };

    function animatedResize(width, height) {
        //Check height
        if (height === undefined) {
            console.log("animatedResize - parameter height undefined");
            return;
        }
        if (isNaN(height)) {
            console.log("animatedResize - parameter height NaN");
            return;
        }
        //Check width
        if (width === undefined) {
            console.log("animatedResize - parameter width undefined");
            return;
        }
        if (isNaN(width)) {
            console.log("animatedResize - parameter width NaN");
            return;
        }

        if(intervalId !== undefined) {
            console.log("Cannot animation - animation already in progress!");
            return;
        }

        if (inline_fragment == null) {
            inline_fragment = document.getElementById('vrv-inline-ad-container');
        }
        //Get actual height and tick form there
        var posY = parseInt(inline_fragment.style.height.replace('px', ''));
        var posX = parseInt(inline_fragment.style.width.replace('px', ''));
        var isExpandY = posY < height;
        var isExpandX = posX < width;

        function animate() {

            var doneX = false;
            var doneY = false;

            if (isExpandX) {
                if (posX < width) {
                    posX++;
                } else {
                    doneX = true;
                }
            } else {
                if (posX > width) {
                    posX--;
                } else {
                    doneX = true;
                }
            }


            if (isExpandY) {
                if (posY < height) {
                    posY++;
                } else {
                    doneY = true;
                }
            } else {
                if (posY > height) {
                    posY--;
                } else {
                    doneY = true;
                }
            }

            if (doneX && doneY) {
                MiddleAdAndroidBridge.onAnimationEnd();
                clearInterval(intervalId);
                intervalId = undefined;
            } else {
                 inline_fragment.style.width = posX + 'px';
                 inline_fragment.style.height = posY + 'px';
                 getInlineFragmentOffset();
                 MiddleAdAndroidBridge.onAnimationTick(posX, posY);
            }
        };

        intervalId = setInterval(animate, 1);

    };


    function resize(width, height) {
        //Check height
        if (height === undefined) {
            console.log("resize - parameter height undefined");
            return;
        }
        if (isNaN(height)) {
            console.log("resize - parameter height NaN");
            return;
        }
        //Check width
        if (width === undefined) {
           console.log("resize - parameter width undefined");
           return;
        }
        if (isNaN(width)) {
           console.log("resize - parameter width NaN");
           return;
        }
        inline_fragment.style.width = width + 'px';
        inline_fragment.style.height = height + 'px';
        getInlineFragmentOffset();
        MiddleAdAndroidBridge.onResized();
    };
